;Draw shape Demo

;Written by Thomas A. Stevenson (aka wargamer)

;www.wargame-programming

;Version 1.0

;3/21/2001

;BlitzBasic 1.43



;This program is piece of object orientated map editor that I am creating

;i.e. instead of tiles, roads and rivers will be represented as

;bezeir curves, Terrain as images overlays, and text as text objects.



;I am posting this because I thought the Menu and linked list systems

;for line segiments might be of interest to others.

;They could have been done with Types instead of arrays with some

;possible advantage, but I don't have a high level of comfort with Types

;The program also makes good use of forms and the simpler Alert and message 

;functions

;The live bezier, line, and fractal editing features are pretty cool too.



;To use

;Drag with the left mouse button pressed to create a new master rectangle

;click on any master to edit it.  (Left) Drag any point or size bar to 

;reposition or resize.  The square is the fill point.

;The master can be relocated by draging anywhere inside

;Right click on a master to pop-up the master menu

;Right click on a (non-control) point to pop-up the point menu

;Click outside the master to return to mode 1

;Mode 1 = no master selected, new masters can be created

;Mode 2 = master selected for editing



;Comments and suggestions welcomed







;Program, Screen and Map Globals

Const  ScrnW=800, ScrnH=600 

Global mapX, mapY,MaxMapX=2000,MaxMapY=2000

Global WinX=20,WinY=50, winH=scrnH-WinY-20, WinW=ScrnW-WinX-20

Global ScreenImage,Hslider,Vslider

Global arial12,arail12Height

Global default_fill=1,PopupHand,Popup1,SegimentMenu,PoPup2,TBAR1

Global PropertiesHand, PatObj, patternHand

Global FractMenu,magIndex,repsIndex,DecIndex



Dim    bordername$(3)

Global BorderDefault=2

bordername$(0)="   NA   ": bordername$(1)="  Line  "

bordername$(2)=" Fractal": bordername$(3)=" Bezier "



;Master Rectangle and line segment globals

Const  LowB=256*256-1

Const  LockBit =1 Shl 17

Global nMasRect,nLineSeg,mode=1,cMast,cseg

Dim    MasRect(100,14), LineSeg(2000,6), pattern(16), pts(8)



Dim	   scdat(8,3)		;default data for new line segiments

Restore segCalcData

For i= 1 To 8

  For j=0 To 3

	Read scdat(i,j)

	Next

Next



;Flood Fill globals

Global currentP,LastP,ActiveP,MaxP=2000

Dim PList(1)

Dim dirX(4),dirY(4)

diry(1)=-1:dirx(2)= 1:dirY(3)= 1:dirx(4)=-1



;Message,Menu, and Mouse Globals

Dim    MessageTxt$(1)

Const  nMenus=4,nSubMenus=6

Dim    nSubm(nMenus,2), Submenu$(nMenus,nSubMenus)  

Dim    ret$(nMenus,nSubMenus), keyVal(nMenus,nSubMenus)

Global MouseImage,MousePointer,MouseCross

Global MenuFnt,MenuWidth,MenuHeight

Restore menudata

menu_load()



;Form and Alert Globals

Dim Atext$(10),Button$(3)

Global Tot_obj=0,MaxDialogItems=30

Dim obj(100,8),objText$(100),Form(10,MaxDialogItems),DList$(100),ReturnText$(100)



;ColorSet globals

Const black=0,white=1,red=2,Green=3,Blue=4,gray=5,LtGray=6

Dim pal(10,2)

ColorDefine(0,0,0,black)

ColorDefine(255,255,255,white)

ColorDefine(255,0,0,red)

ColorDefine(0,255,0,green)

ColorDefine(0,0,255,blue)

ColorDefine(100,100,100,gray)

ColorDefine(200,200,200,LtGray)





;*********************************  Start *********************************

Graphics_start()

Forms_Load()



mapX=0

MapY=0

MoveMouse(200,200)

DrawScreenImage(ScreenImage,0)



main()



;Functions ****************************************************

Include "Graphics Functions.bb"

Include "Menu Functions.bb"

Include "Form Functions.bb"

Include "Object Functions.bb"





Function Main()  ;**************************************************************



  Repeat

		ScrollMapKeys(ScreenImage)

		mx=MouseX()

		my=MouseY()

		;translate screen coordinates to map coordinates

		sx=mx-WinX+MapX	

		sy=my-WinY+MapY

		DrawBlock ScreenImage,0,0

		DrawImage MouseImage, mx,my

		UpdatePosition(mx,my,"Main")

		Flip

	

		;check position of mouse versus screen elements

		If RectsOverlap(mx,my,1,1,WinX,WinY,WinW,WinH)

			;inside Map Window/play area

			Select mode

			Case 1	;No Master Rectangle selected

			  If MouseDown(1) Then 

					cMast=Master_Find(sx,sy)

					If cMast=0 Then

						;not on master

		 			  If Master_Resize(cMast,sx,sy,ScreenImage)  ;never true here

							;resize

					  Else

							;add a new master

					  	MouseImage=MousePointer

					  	Master_Add(mx,my,ScreenImage)

					  	MouseImage=MouseCross

				  	  Flip

					  EndIf

					Else

						;Master selected, draw cmast with segiments visible

					  MouseImage=MousePointer

					  DrawScreenImage(ScreenImage,cMast)

					  DrawBlock ScreenImage,0,0	

					  Master_Draw(cMast)

					  GrabImage ScreenImage,0,0

					  mode=2

					EndIf

			  ElseIf MouseDown(2) Then

					;if on master pop-up menu

					cMast=Master_Find(sx,sy)

					If cMast>0 Then 

						Master_PopUp(mx,my,cMast,screenimage)

						DrawScreenImage(screenimage,0)

					EndIf

			  EndIf

			Case 2  ;Mode 2, There is master currently selected

							;edit points inside Master Rect

				If MouseDown(1) Then 

					;check for mouse on a point

					Cseg=Point_Find(cMast,sx,sy)

					If Control_Find(cMast,sx,sy,ScreenImage)

					ElseIf cSeg=-1 Then  ;outside master rect

					  If Master_Resize(cMast,sx,sy,ScreenImage)

							;clicked on control tab

					  Else

					    ;outside master rect return to mode 1

							Master_Image(cMast)

							cMast=0

							DrawScreenImage(ScreenImage,0)

					    MouseImage=MouseCross

					    mode=1

					  EndIf   

					ElseIf Master_Center(cMast,sx,sy,ScreenImage)

						;moves centerpoint

					ElseIf cSeg=0 Then

						;inside master but not on a point 

					  Master_Move(cMast,ScreenImage)			

					Else  ;cSeg>0

					  Point_Move(cSeg,cMast,ScreenImage)

					EndIf

				ElseIf MouseDown(2) Then

					Cseg=Point_Find(cMast,sx,sy)		

					If cSeg=-1 Then		

					  ;outside master rect return to mode 1

					  MouseImage=MouseCross

					  Master_Image(cMast)

					  mode=1

					  While MouseDown(2): Wend	;wait for mouse release

					  MoveMouse(mx,my)

					ElseIf cSeg=0 Then

					 	;right click inside master rect

						Master_PopUp(mx,my,cMast,screenimage)

						;refresh screen

						DrawScreenImage(screenimage,cMast)

					  DrawBlock ScreenImage,0,0	

					  Master_Draw(cMast)

					  GrabImage ScreenImage,0,0

					Else

						;right click on point, pop-up point menu

						Segiment_Popup(mx,my,cMast,cSeg,ScreenImage)

					EndIf

					While MouseDown(2): Wend

				EndIf

			Default

			End Select

	  ElseIf Slider(mx,my,ScreenImage)

			;process slider event

	  ElseIf MENU_Activate (mx,my)

			;process menu event

	  	MouseImage=MousePointer		

			menupick$=MENU_Get$ (mx,ScreenImage)

			Menu_Process(menupick$,ScreenImage)

	  	If mode=1 Then MouseImage=MouseCross

	  EndIf  ;where on screen

		;check menu hotkeys

		hotkey$=MENU_KEY()

		Menu_Process(hotkey$,ScreenImage)

		FlushKeys

  Forever

  End



End Function





Function MENU_Process (Pick$,img)

  Select  Pick$

  Case ""

	Case "SCRN"

		f$="Draw Shape.bmp" 

		saveBMP(f$)

		message("Screen saved as "+f$,3000,img)

  Case "LOAD"

		LoadShapeData("Shapedata.bin",img)

  Case "SAVE"

		SaveShapeData("Shapedata.bin",img)

  Case "QUIT"

		Dim Atext$(10)

		Atext$(1)="Draw Shape Demo V 1.0"

		Atext$(2)="3/21/2001"

		Atext$(3)="Thomas A. Stevenson"

		Atext$(4)=""

		Atext$(5)="Are You Sure You want to Quit?"

		button$(1)="QUIT"

		button$(2)="CANCEL"

		If ALERT(6,2,img)=1 Then End

  Case "LOCK"

		If cMast<1 Then Return

		Dim Atext$(10)

		Atext$(1)="       Master Rectangle "+Str$(cMast)

		If MasRect(cMast,13) And lockbit Then 

		  Atext$(2)="     is currently Locked         " 

		Else 

		  Atext$(2)="    is currently not Locked       "

		EndIf

		Atext$(3)="  Do Wish to (un)Lock it?"

		button$(1)=" Lock " 

		button$(2)="Unlock" 

		button$(3)="Cancel"	

		choice=ALERT(4,3,img)

		If choice=1 Then MasRect(cMast,13)=(MasRect(cMast,13) And lowB) + lockbit 

		If choice=2 Then MasRect(cMast,13)=MasRect(cMast,13) And lowB

  Case "FILL"

		Origin 0,0

		DrawBlock img,0,0

		Origin 300,200

		DrawBlock pattern(0),0,0

		Flip

		Color 255,255,255

		Repeat: Until Not MouseDown(1)



		Repeat

			mx=MouseX()

			my=MouseY()

			DrawBlock img,0,0

			Origin 300,200

			sx=mx-300: sy=my-200

			DrawBlock pattern(0),0,0

			

			If sx>0 And sy>0 Then

			  If sx<160 And sy<240 Then 

					newfill=1+sx/40+4*Int(sy/60)

					Text 0,-20,Str$(newFill)

				Else

					newfill=-1

			  EndIf

			EndIf

			Origin 0,0

			DrawImage mouseImage,mx,my

			Flip

		Until MouseDown(1)



		Repeat: Until Not MouseDown(1)

		If newfill <>-1 Then

			locked=(MasRect(cMast,13) And lockbit) 

			MasRect(cMast,13)= newfill + locked

			If newFill<>default_fill Then

			  default_fill=newFill

			  message("Default Fill change to "+Str$(newFill),3000,img)

	    EndIf

		EndIf

  Case "BORD"

		Dim Atext$(10)

		Atext$(1)=" Change Border type for selected Master"

		Atext$(2)=" and default border type for new Masters"

		Atext$(3)=" Current Border type is "+bordername$(cMast)

		Atext$(4)=" Default Border type is "+bordername$(BorderDefault)

		button$(1)= bordername$(1)

		button$(2)= bordername$(2)

		button$(3)= bordername$(3)

		choice=ALERT(5,3,img)

		BorderDefault=choice

		If cMast>0 Then

	  	If choice<>MasRect(cMast,0) Then

				MasRect(cMast,0)=choice

				Seg=MasRect(cMast,5)

				Repeat

	  	  	Point_set(cMast,Seg)

	  	  	seg=LineSeg(Seg,5)

	      	If seg<0 Then Exit	

				Until Seg=MasRect(cMast,5)

				Master_MinMax(cMast)

			 	Master_Image(cMast)

				DrawScreenImage(img,0)

			EndIf

		EndIf

  Case "DEL"

		Master_Delete(cMast,img)

  Case "COPY"

		Master_Copy(cMast,img)

  Case "DSEG"

		Point_Delete(cSeg,cMast,img)

  Case "ISEG"

		Point_Insert(cSeg,cMast,img)

  Case "PSEG"

		If MasRect(cMast,0)=2 Then 

			fractal_Properties(cMast,cSeg,img)

		EndIf

  Case "CRED"

		Dim Atext$(10)

		Atext$(1)="Draw Shape Demo V 1.0"

		Atext$(2)="3/19/2001"

		Atext$(3)="Thomas A. Stevenson"

		Atext$(4)="wwww.wargame-programming.com"

		Atext$(5)="Created with Blitz Basic 1.43"

		button$(1)=" OK "

		choice=ALERT(6,1,img)

  Default

  End Select 



End Function





Function UpdatePosition(mx,mY,funct$)

	sx=mx+MapX-WinX

	sy=my+MapY-WinY

	If arial12>0 Then SetFont arial12

	fw=FontHeight()+2

	Color 255,255,255

	Text WinX,MenuHeight+2,  "Mouse "+Str$(sx)+" "+ Str$(sy)

	Text WinX+200,MenuHeight+2,"Mode: "+Str$(mode)

	Text WinX+200,MenuHeight+2+fw,funct$

	Text WinX+300,MenuHeight+2, "Master:  "+Str$(cMast)

	If MasRect(cMast,13) And lockbit Then Text WinX+400,MenuHeight+2,"Locked"

	If cSeg=-1 Then

	  Text WinX+300,MenuHeight+2+fw,"Segment: "

	Else

	  Text WinX+300,MenuHeight+2+fw,"Segment: "+Str$(cSeg)

	EndIf

End Function





Function DrawScreenImage(img,except)

	Cls

	Color 100,100,100

	Rect WinX,WinY,WinW,WinH	

	Viewport WinX,WinY,WinW,WinH	

	For i= 1 To nMasRect

	  If i<> except Then 

			If MasRect(i,14)>0 Then 

				mhand=MasRect(i,14)

			  DrawImage MasRect(i,14),MasRect(i,1)-MapX+WinX,MasRect(i,2)-MapY+WinY

			ElseIf MasRect(i,0)=0

			Else

			  Master_Draw(i)	

			EndIf

	  EndIf

	Next 

	Viewport 0,0,scrnW,ScrnH



 	w1=WinH*WinH/(MaxMapY)  ;Vertical slider size 

	w2=WinW*WinW/(MaxMapX)  ;Horizontial slider size 

	Ypos=WinY+MapY*(WinH-w1)/(MaxMapY-WinH)

	Xpos=WinX+MapX*(WinW-w2)/(MaxMapX-WinW)

	Color 0,255,0

	DrawBlock vslider,WinX+WinW,WinY

	DrawBlock hslider,WinX,WinY+WinH

	ButtonBox(WinX+WinW,yPos,12,w1,"",0,LtGray,0,False)

	ButtonBox(Xpos,WinY+WinH,w2,12,"",0,LtGray,0,False)

	MENU_DRAW()

	GrabImage img,0,0

	

End Function 











Function Graphics_start()

	Graphics ScrnW,ScrnH

	SetBuffer BackBuffer()

	MenuFnt=LoadFont("times new roman",18,1)

	MenuWidth=FontWidth()*12

	MenuHeight=FontHeight()+6

	arial12=LoadFont("Arial",14)

	arail12Height=FontHeight()+2

	

	Hslider=SliderBackground(WinW,12)

	Vslider=SliderBackground(12,WinH)

	

	Cls

	Color 100,100,100

	Rect WinX,WinY,WinW,WinH

	ScreenImage=CreateImage(scrnW,scrnH)

	GrabImage ScreenImage,0,0

	

	

	Restore pointerdata

	MousePointer=LoadMouse()

	Restore Movepointerdata

	MouseCross=LoadMouse()

	MouseImage=MouseCross

	

	f$="Fill Paterns.bmp"

	pattern(0)=LoadImage (f$)

	patternHand=CreateImage(30,30,17)

	If pattern(0)>0 Then 

		DrawBlock pattern(0),0,0

		For i=0 To 15

			x=(i Mod 4)*40+1

			y=Int(i/4)*60+1

			pattern(i+1) = CreateImage (39,59)

			GrabImage pattern(i+1),x,y

			GrabImage patternHand,x,y,i+1

		Next 

		FreeImage pattern(0)

	Else

	  	message(f$+" not found|Using solid fills.",5000,screenimage)

		For i=0 To 15

			x=(i Mod 4)*40+1

			y=Int(i/4)*60+1

			Color 255,0,0

			Rect x-1,y-1,40,60,0

			Color Rnd(255),Rnd(255),Rnd(255)

			Rect x,y,39,59

			pattern(i+1) = CreateImage (39,59)

			GrabImage pattern(i+1),x,y

		Next 

	EndIf

	pattern(0) = CreateImage (161,241)

	GrabImage pattern(0),0,0

	 

	For i=1 To nMenus: 	Menu_image(i): Next 

End Function





Function	SaveShapeData(file$,img)



	f=WriteFile(file$)

	WriteInt f,nMasRect

	WriteInt f,nLineSeg

	For m=1 To nMasRect

		For i=0 To 14

			WriteInt f,MasRect(m,i)

		Next

	Next

	For s=1 To nLineSeg

		For i=0 To 6

			WriteInt f,LineSeg(s,i)

		Next 

	Next

	CloseFile f	

	message("Data saved to "+file$,3000,img)

	

End Function





Function LoadShapeData(file$,img)



	If FileType(file$)=0

		message(file$+" File not found",3000,img)

		Return

	EndIf

	;erase current master images

	For m=1 To nMasRect

		FreeImage MasRect(M,14)

	Next

	;zero out shape arrays

	Dim MasRect(100,14),LineSeg(2000,6)

	

	f=ReadFile(file$)

	nMasRect=ReadInt(f)

	nLineSeg=ReadInt(f)

	For m=1 To nMasRect

		For i=0 To 14

			MasRect(m,i)=ReadInt(f)

		Next

	Next

	For s=1 To nLineSeg

		For i=0 To 6

			LineSeg(s,i)=ReadInt(f)

		Next 

	Next

	CloseFile f	

	

	;create new screen

	mode=1

	For m=1 To nMasRect

		Master_Image(m)

	Next

	DrawScreenImage(img,0)



End Function





Function Forms_Load()

	

	;Form 1:  Popup menu for master rectangles

	bw=90:	bh=20:	x=0

	popup1=obj_assign(1,0,200,200,bw,bh*5,Black,LtGray,NewRoman,-1,"","")

	TBAR1=obj_assign(1,9,0,0,bw,bh,Black,Blue,MenuFnt,2,"Master ##","FRM1")

	obj_assign(1,3,x,1*bh,bw,bh,LtGray,Black,MenuFnt,False," Delete ","DEL")

	obj_assign(1,3,x,2*bh,bw,bh,LtGray,Black,MenuFnt,False," Copy   ","COPY")

	obj_assign(1,3,x,3*bh,bw,bh,LtGray,Black,MenuFnt,False," Properties","PROP")

	obj_assign(1,3,x,4*bh,bw,bh,LtGray,Black,MenuFnt,False," Cancel ","CAN")

	

	;Form 2:  Form to set master properties

	obj_assign(2,0,200,200,300,200,LtGray,Black,MenuFnt,-1,"","")

	obj_assign(2,9,0,0,300,20,Black,Blue,NewRoman,2,"Master Properties","TBAR")

	obj_assign(2,4,10,40,17,17,0,0,0,False, "Locked","LOCK")

	obj_assign(2,5,10,70,  17,17,False,1,NewRoman,0,bordername$(1),"1")

	obj_assign(2,5,10,90,  17,17,False,1,NewRoman,0,bordername$(2),"2")

	obj_assign(2,5,10,110, 17,17,False,1,NewRoman,0,bordername$(3),"3")



	x2=120

	s$=   LSet$("Woods",10)

	s$=s$+LSet$("City",10)

	s$=s$+LSet$("Swamp",10)

	s$=s$+LSet$("Rough",10)

	s$=s$+LSet$("Orchard",10)

	s$=s$+LSet$("Crosshatch",10)

	s$=s$+LSet$("Yellow",10)

	s$=s$+LSet$("Gray",10)

	obj_assign(2,12,x2,40,120,20,8,10,NewRoman,1,s$,"FILL")

	FDelay=1 Shl 30					;set frame delay to >24h so that it only changes

													;when we change fills

	Framedata=16 + 1 Shl 16	;low Word=# of frames, high word = current frame

	PatObj=obj_assign(2,13,x2,70,30,30,patternHand, 0, FDelay,FrameData,"","")

	;buttons

	obj_assign(2,3,180,170,100,20,Red,ltgray,NewRoman,False,"DONE","DONE")

	obj_assign(2,3,20,170,100,20,Red,ltgray,NewRoman,False,"Set Fractal","FRAC")

	PropertiesHand=Form_Image(2)



;Form 3:  Popup menu for line segiments

	bw=90:	bh=20:	x=0

	popup2=obj_assign(3,0,200,200,bw,bh*4,Black,LtGray,NewRoman,-1,"","")

	obj_assign(3,3,x,0*bh,bw,bh,LtGray,Black,MenuFnt,False," Delete ","DEL")

	obj_assign(3,3,x,1*bh,bw,bh,LtGray,Black,MenuFnt,False," Insert   ","INS")

	obj_assign(3,3,x,2*bh,bw,bh,LtGray,Black,MenuFnt,False," Set fractal","FPROP")

	obj_assign(3,3,x,3*bh,bw,bh,LtGray,Black,MenuFnt,False," Cancel ","CAN")

	

;Form 4: fractal settings

	obj_assign(4, 0,400,20,300,180,LtGray,RED,NewRoman,-1,"","")

	obj_assign(4, 9,0,0,300,20,Black,Blue,NewRoman,2,"fractal Settings","TBAR")

	obj_assign(4,-1,10,150,100,20,Black,False ,NewRoman,0,"Current Segiment","SEGNUM")

	magIndex= obj_assign(4,7,100,30,100,12,True,4,100,4,"","MAG")

	repsIndex=obj_assign(4,7,100,50,100,12,True,2,8,2,"","REPS")

	DecIndex= obj_assign(4,7,100,70,100,12,True,25,100,25,"","DECAY")

	obj_assign(4,1,10,30,100,20,Black,False ,NewRoman,0,"Magitude","")

	obj_assign(4,1,10,50,100,20,Black,False ,NewRoman,0,"Cycles","")

	obj_assign(4,1,10,70,100,20,Black,False ,NewRoman,0,"Decay Factor","")

	obj_assign(4,4,10,90,17,17,0,0,0,False, "Effect All Segments","ALL")

	obj_assign(4,3, 10,120,80,20,gray,ltgray,NewRoman,False,"Reset","RESET")

	obj_assign(4,3,110,120,80,20,gray,white,NewRoman,False,"Next","NEXT")

	obj_assign(4,3,210,120,80,20,gray,white,NewRoman,False,"DONE","DONE")

	FractMenu=Form_Image(4)

	

End Function





Function Master_PopUp(x,y,M,img)



	obj(popup1,1)=x

	obj(popup1,2)=y

	objText$(TBAR1)="  Master "+M

	PopupHand=Form_Image(1)

	Repeat

		ObjIndex=form_control(1,PopupHand,img)

		Select ReturnText$(ObjIndex)

		Case ""

		Case "DEL"

			Master_Delete(M,img)

			Exit

		Case "COPY"

			Master_Copy(M,img)

			Exit

		Case "PROP

			Mast_Properties(M,img)

			Exit

		Case "CAN"

			Exit 

		End Select

	Forever

	obj(ObjIndex,8)=False

	FreeImage PopupHand

	

End Function





Function Mast_Properties(M,img)



	;set Form properties base on Master Rect M

	For n=1 To Form(2,0)

		i=Form(2,n)

		If ReturnText$(i)="LOCK"

			If MasRect(M,13) And lockbit Then obj(i,8)=True Else obj(i,8)=False

		EndIf

	Next

	For n=1 To Form(2,0)

		i=Form(2,n)

		If ReturnText$(i)="FILL"

			obj(i,8)=MasRect(M,13) And lowB

			obj(PatObj,8)=16 + obj(i,8) Shl 16

		EndIf

	Next

	For n=1 To Form(2,0)

		i=Form(2,n)

		If ReturnText$(i)="1"

			If MasRect(M,0)=1 Then obj(i,5)=True Else obj(i,5)=False

		ElseIf ReturnText$(i)="2"

			If MasRect(M,0)=2 Then obj(i,5)=True Else obj(i,5)=False

		ElseIf ReturnText$(i)="3"

			If MasRect(M,0)=3 Then obj(i,5)=True Else obj(i,5)=False

		EndIf

	Next

	

	;Put Form on screen and get user choices

	Repeat

		ObjIndex=form_control(2,PropertiesHand,img)

		Select ReturnText$(ObjIndex)

		Case ""

		Case "DONE"

			obj(ObjIndex,8)=False

			Exit

		Case "FILL"

			locked=(MasRect(M,13) And lockbit) 

			MasRect(M,13)=obj(ObjIndex,8)+locked

			obj(PatObj,8)=16 + obj(ObjIndex,8) Shl 16

		Case "LOCK"

			If obj(ObjIndex,8) Then

				MasRect(M,13)=(MasRect(M,13) And lowB) + lockbit 

			Else

				MasRect(M,13)=(MasRect(M,13) And lowB)  

			EndIf

		Case "1","2","3"

			MasRect(M,0)= ReturnText$(ObjIndex)  ;force string to integer conversion

			Seg=MasRect(M,5)

			Repeat

  	  	Point_set(M,Seg)

  	  	seg=LineSeg(Seg,5)

      	If seg<0 Then Exit	

			Until Seg=MasRect(M,5)

			Master_MinMax(M)

		 	Master_Image(M)

		Case "FRAC"

			obj(ObjIndex,8)=False

			If MasRect(M,0)=2 Then 

				fractal_Properties(M,MasRect(M,5),img)

			Else

				Message("Not a Fractal type object!",3000,img)

			EndIf

		End Select

	Until KeyDown(1)

End Function





Function Segiment_Popup(x,y,M,S,img)



	obj(PopUp2,1)=x

	obj(PopUp2,2)=y

	If MasRect(M,0)=2 Then 

		Form_Object("FPROP",6,Black)

	Else

		Form_Object("FPROP",6,White)

	EndIf

	SegimentMenu=Form_Image(3)

	Repeat

		ObjIndex=form_control(3,SegimentMenu,img)

		Select ReturnText$(ObjIndex)

		Case ""

		Case "DEL"

			Point_Delete(S,M,img)

			Exit

		Case "INS"

			Point_Insert(S,M,img)

			Exit

		Case "FPROP

			If MasRect(M,0)=2 Then 

				fractal_Properties(M,S,img)

				Exit

			Else

				obj(ObjIndex,8)=False

			EndIf

		Case "CAN"

			Exit 

		End Select

	Forever

	obj(ObjIndex,8)=False

	FreeImage SegimentMenu

	

End Function





Function fractal_Properties(M,Seg,img)



	Mag0=LineSeg(Seg,4) And 255				

	rep0=(LineSeg(Seg,4) Shr 8) And 255

	dec0=((LineSeg(Seg,4) Shr 16) And 255) 

	obj(magIndex,8)=LineSeg(Seg,4) And 255				

	obj(repsIndex,8)=(LineSeg(Seg,4) Shr 8) And 255

	obj(DecIndex,8)=((LineSeg(Seg,4) Shr 16) And 255) 

	AllB=Form_Object("ALL",-1,-1)

	obj(ALLB,8)=False	;reset all check box to off

	segn=Form_Object("SEGNUM",-1,-1)

	objText$(segn)="Current Segiment "+seg

	Repeat

		ObjIndex=form_control(4,FractMenu,img)

		Select ReturnText$(ObjIndex)

		Case "NEXT"

			Seg=LineSeg(Seg,5)

			Mag0=LineSeg(Seg,4) And 255				

			rep0=(LineSeg(Seg,4) Shr 8) And 255

			dec0=((LineSeg(Seg,4) Shr 16) And 255) 

			obj(magIndex,8)=LineSeg(Seg,4) And 255				

			obj(repsIndex,8)=(LineSeg(Seg,4) Shr 8) And 255

			obj(DecIndex,8)=((LineSeg(Seg,4) Shr 16) And 255) 

			objText$(segn)="Current Segiment "+seg

			obj(ObjIndex,8)=False	;reset button

		Case "MAG"

		  LineSeg(Seg,4)=obj(magIndex,8)+(obj(repsIndex,8) Shl 8)+(obj(DecIndex,8) Shl 16)

			If obj(AllB,8) Then value=LineSeg(Seg,4) Else value=0

			fractal_update(M,Seg,img,Value)		

		Case "REPS"

		  LineSeg(Seg,4)=obj(magIndex,8)+(obj(repsIndex,8) Shl 8)+(obj(DecIndex,8) Shl 16)

			If obj(AllB,8) Then value=LineSeg(Seg,4) Else value=0

			fractal_update(M,Seg,img,Value)		

		Case "DECAY"

		  LineSeg(Seg,4)=obj(magIndex,8)+(obj(repsIndex,8) Shl 8)+(obj(DecIndex,8) Shl 16)

			If obj(AllB,8) Then value=LineSeg(Seg,4) Else value=0

			fractal_update(M,Seg,img,Value)		

		Case "RESET"

		  LineSeg(Seg,4)=mag0+(rep0 Shl 8)+(dec0 Shl 16)

			If obj(AllB,8) Then value=LineSeg(Seg,4) Else value=0

			fractal_update(M,Seg,img,Value)		

		Case "DONE"

			obj(ObjIndex,8)=False	;reset button

			Exit

		Case "ALL"

		  value=obj(magIndex,8)+(obj(repsIndex,8) Shl 8)+(obj(DecIndex,8) Shl 16)

			If obj(AllB,8) fractal_update(M,Seg,img,Value)		

		End Select

	Until KeyDown(1)



End Function





Function fractal_update(M,Seg,img,Value)		



	If Value=0

		DrawBlock img,0,0	

		DrawScreenImage(img,M)

		Master_Draw(M)

		GrabImage img,0,0

	Else

		nextSeg=MasRect(M,5)

		Repeat

			LineSeg(nextSeg,4)=value

		  nextSeg=LineSeg(nextSeg,5)

		  If nextseg<0 Then Exit	

		Until nextSeg=MasRect(M,5)

		DrawBlock img,0,0	

		DrawScreenImage(img,M)

		Master_Draw(M)

		GrabImage img,0,0

	EndIf

	

End Function



Function DrawLineSeg(M,Seg,ControlPoints)	

	If LineSeg(Seg,0)<>M Then Stop: Return -1

	nxt=LineSeg(Seg,5)

	Color 0,255,0

	If ControlPoints Then Color 255,255,255

	Select MasRect(M,0)

	Case 1	;line

	  Line LineSeg(Seg,1),LineSeg(Seg,2),LineSeg(Nxt,1),LineSeg(nxt,2)

	Case 2	;fractal

	  SeedRnd LineSeg(Seg,3)

	  mag=LineSeg(Seg,4) And 255

	  Reps=(LineSeg(Seg,4) Shr 8) And 255

	  D=((LineSeg(Seg,4) Shr 16) And 255)

	  Decay#=((LineSeg(Seg,4) Shr 16) And 255)/100.00

		fracture( LineSeg(Seg,1),LineSeg(Seg,2),LineSeg(Nxt,1),LineSeg(nxt,2),mag,decay#,Reps)

	Case 3	;bezier

	  divide(LineSeg(Seg,1),LineSeg(Seg,2),LineSeg(Seg,3),LineSeg(Seg,4),LineSeg(Nxt,1),LineSeg(nxt,2) ,0,0,3)

	  Color 255,0,255

	  If ControlPoints Then Rect LineSeg(Seg,3)-1,LineSeg(Seg,4)-1,3,3

	End Select

	If ControlPoints	

	  Color 255,0,0

	  Rect LineSeg(Seg,1)-1,LineSeg(Seg,2)-1,3,3

		If seg=cSeg Then 

	  	DrawRect(LineSeg(Seg,1),LineSeg(Seg,2),LineSeg(nxt,1),LineSeg(nxt,2),0)

		EndIf

	EndIf

	Return nxt

End Function





.menudata

Data 1,"File","",0

Data 1,"  Load  F7",		"LOAD",65

Data 1,"  Save F10",		"SAVE",68

Data 1,"  Quit esc",		"QUIT",1

Data 2,"Master",				"",0

Data 2,"  Properties",  "MASTP",0

Data 2,"  (un)Lock",		"LOCK",0

Data 2,"  Set Fill",		"FILL",0

Data 2,"  Set Border",	"BORD",0

Data 2,"  Delete",			"DEL",0

Data 2,"  Copy",				"COPY",0

Data 3,"Segment",				"SEG",0

Data 3,"  Properties",	"PSEG",0

Data 3,"  Delete ",			"DSEG",0

Data 3,"  Insert",			"ISEG",0

Data 4,"About",					"",0

Data 4,"  Credits  F1",	"CRED",59

Data 4,"  Snapshot F2",	"SCRN",60

Data 4,"END MENU DATA",		"",0





.segCalcData

Data  1, 7,0,0

Data  1,-1,1,0

Data  1,-1,2,0

Data  1,-1,2,1

Data  1,-1,2,2

Data  1,-1,1,2

Data  1,-1,0,2

Data -7,-1,0,1