Function ButtonBox(x,y,w,h,r$,fnt,fillcolor,txtcolor,Pressed)

	;draws text inside a define box on current buffer

	If fnt<>0 Then SetFont fnt

	If w=0 Then w=StringWidth(r$)+4

	If h=0 Then h=FontHeight()+4

	

 	ColorSet(White)

 	Rect x,y,w,h

	colorSet(fillcolor)		;Fill

	Rect x+1,y+1,w-2,h-2

	colorSet(txtcolor)		;Text

	Text x+1+w/2,y-1+h/2,r$,1,1

	ColorSet(Black)

	If Pressed 

	  Line x,y,x+w,y: Line x,y,x,y+h

	Else

	  Line x+1,y+h-1,x+w,y+h-1: Line x+w-1,y+1,x+w-1,y+h

	EndIf

	

End Function





Function LoadMouse()

	

	Read w,h, hx,hy

	If w>32 Then

	  m=CreateImage(w,h)

	Else

	  ;image must be wider than 32 pixels to work on my laptop

	  m=CreateImage(33,h)	

	EndIf

	SBuffer=ImageBuffer(m)

	SetBuffer SBuffer

	

	LockBuffer 

	  For y=0 To h-1

		For x=0 To w-1

		  Read rgb

		  WritePixelFast(x,y,rgb)

		Next

	  Next

	UnlockBuffer

	HandleImage m,hx,hy

	SetBuffer BackBuffer()

	

	Return m

	

End Function





Function HexDraw(X,Y,W,H,A)

	X0=X-A

	X1=X+A

	X2=X+W-A

	X3=X+W+A

	Y2=Y+H

	Y12=Y+H/2

    Line X0,Y12,X1,Y

	Line X1,Y,X2,Y

	Line X2,Y,X3,Y12

	Line X3,Y12,X2,Y2

	Line X2,Y2,X1,Y2

	Line X1,Y2,X0,Y12

End Function





Function saveBMP(f$)

	zhand=CreateImage (scrnW,ScrnH)

	GrabImage zhand,0,0

	SaveImage zhand,f$

	FreeImage zHand

End Function

	



Function divide(x0,y0, x1,y1, x2,y2, w0,w2,counter) ; curve control point is middle 

	;RobinS Quadratic Bezier Curve Function Posted 12-12-2000 19:19 

	If counter = 0

		drawline(x0,y0,x2,y2,w0,w2)

		Return True 

	Else 

		xsplit = (x0+x1)/2 

		ysplit = (y0+y1)/2 

		xsplit2 = (x1+x2)/2 

		ysplit2 = (y1+y2)/2 

		sendX = (xsplit + xsplit2)/2 

		sendY = (ysplit + ysplit2)/2 

		wsp1=(w0+w2)/2

		divide (x0,   y0,   xsplit,  ysplit,  sendX,sendY,w0,  wsp1,counter-1) 

		divide (sendX,sendY,xsplit2, ysplit2, x2,   y2,   wsp1,w2,  counter-1) 

		Return False 

	EndIf 

End Function





Function drawline(x0,y0,x2,y2,w0,w2)



	ww=(w0+w2)/2

	ww2=ww/2

	;Color 255,255,255

	If ww=0 Then

	  Line x0,y0,x2,y2

	  Return

	EndIf

	dx#=x2-x0

	dy#=y2-y0

	r=Sqr#(dx*dx+dy*dy)

	xFact#=dx/r			;sin()

	yfact#=dy/r 		;cos()

	For i=0 To r

		x=i*xFact+x0

		y=i*yfact+y0

		Oval x-ww2,y-ww2,ww,ww

	Next



End Function





Function makeHexTile(CW,CH,A)



	SetBuffer BackBuffer()

	

	;create Hex tile

	RX1=100

	RY1=160

	Color 255,255,255

	Cls

	HexDraw(rx1,ry1-cH,cW,cH,A)

	HexDraw(rx1,ry1,cW,cH,A)

	HexDraw(rx1+cellW,ry1-cH/2,cW,cH,A)

	HexHand = CreateImage(2*cW,2*cH)

	GrabImage HexHand,rx1-A,ry1-cH

	HandleImage HexHand,A,cH/2

	MaskImage HexHand,0,0,0

	Return HexHand

	

End Function



Function colorSet(c)

	Color Pal(c,0),Pal(c,1),Pal(c,2)

End Function





Function ColorDefine(r,g,b,n)

	pal(n,0)=r

	pal(n,1)=g

	pal(n,2)=b

End Function





;Help Functions ****************************************************



Function MiniMax(V,minV,maxV)

	If V<minV Then Return minV

	If V>maxV Then Return maxV

	Return V

End Function



Function Max(a,b)

	If a>b Then Return a Else Return b

End Function



Function MapViewPort(v)

  If v=1 Then

	Viewport WinX,WinY,ScrnW-WinX*2, ScrnH-WinY*2

	Origin WinX-MapX,WinY-MapY

  Else

	Viewport 0,0,ScrnW,ScrnH

	Origin 0,0

  EndIf

End Function





Function ScrollMapKeys(img)

	;MaoX and MapY are global

	MapX2 = MapX

	MapY2 = MapY



	If KeyDown(203) Then mapX=mapX-50    	;left arrow

	If KeyDown(205) Then mapX=mapX+50    	;right arrow

	If KeyDown(15) Then 					;tab key

	  ;is shift key down too?

	  If KeyDown(42) Then MapX=MapX-300 Else MapX=MapX+300

	EndIf

 	If KeyDown(200) Then mapY=mapY-50    	;up arrow

	If KeyDown(208) Then mapY=mapY+50    	;down arrow

	If KeyDown(201) Then mapY=mapY-300   	;page up

	If KeyDown(209) Then mapY=mapY+300   	;page down

	If KeyDown(199) Then mapY=0:mapX=0   	;home

	If KeyDown(207) Then 					;end

	  mapY=MaxMapY:      mapX=MaxMapX  

	EndIf

	

	If MapX<aHex Then MapX=aHex

	If MapY<0 Then MapY=0

	If MapX>(MaxMapX-WinW) Then MapX=(MaxMapX-WinW)

	If MapY>(MaxMapY-WinH) Then MapY=(MaxMapY-WinH)

	If MapX<>MapX2 Or MapY<>MapY2

	  ;redraw map only if necessary

	  DrawScreenImage(img,0)

	  Return True

	EndIf

	Return False

	

End Function









Function Scrn2MapX(x)

  Return x+mapX-WinX

End Function



Function Scrn2MapY(y)

  Return y+mapY-WinY

End Function





Function SliderSize(VisbleRange,TotalRange,SliderRange)

	If SliderRange=0 Then Return SliderRange

	If TotalRange=0 Then Return SliderRange

	If VisbleRange=0 Then Return SliderRange

	Return 	SliderRange*VisbleRange/TotalRange

End Function





Function SliderPosition(Pos,VisbleRange,TotalRange,SliderRange)

	If SliderRange=0 Then Stop

	If TotalRange =0 Then Stop

	If VisbleRange=0 Then Stop

	SLiderSize=SliderRange * VisbleRange/TotalRange

	SliderPos=Pos*(SliderRange-SLiderSize)/(TotalRange-VisbleRange)

	Return SliderPos	

End Function





Function Slider_move(img,S)

	If MouseDown(1)=False Then Return

	If s=1 Then

		DrawBlock img,0,0

		w1=WinH*WinH/(MaxMapY)  ;Vertical slider size 

		Ypos=WinY+MapY*(WinH-w1)/(MaxMapY-WinH)

		shand=CreateImage(12,w1)

		GrabImage sHand,WinX+WinW,Ypos

		MoveMouse WinX+WinW,Ypos

		yMax=WinY+WinH-w1

		While MouseDown(1)

			Ypos=MiniMax(MouseY(),WinY,Ymax)

			DrawBlock vslider,WinX+WinW,WinY

			DrawBlock shand,WinX+winW,Ypos

			Flip

		Wend

		FreeImage sHand	

  	MapY=(Ypos-WinY)*(MaxMapY-WinH)/(WinH-w1)

	Else

		DrawBlock img,0,0 	

		w2=WinW*WinW/(MaxMapX)  ;Horizontial slider size 

		Xpos=WinX+MapX*(WinW-w2)/(MaxMapX-WinW)

		shand=CreateImage(w2,12)

		GrabImage sHand,Xpos,WinY+WinH

		MoveMouse Xpos,WinY+WinH

		Xmax=WinX+WinW-w2

		While MouseDown(1)

			Xpos=MiniMax(MouseX(),WinX,Xmax)

			DrawBlock hslider,WinX,WinY+WinH

			DrawBlock shand,Xpos,WinY+winH

			Flip

		Wend

		FreeImage sHand			  

		MapX=(Xpos-WinX)*(MaxMapX-WinW)/(WinW-w2)

	EndIf



End Function



Function SliderBackground(w,h)

  ;draws to current buffer and dosn't cleanup

	;Set origin before calling

  colorset(white)

  Rect 0,0,w,h

  colorset(LtGray)

  For y=0 To h

	x0= y Mod 2

  	For x=x0 To w Step 2

	  Plot x,y

	Next

  Next

  shand=CreateImage(w,h)

  GrabImage shand,0,0

  Return shand

End Function





Function Slider(mx,my,img)

	If MouseDown(1)=False Then Return False

  Mapx2=MapX

  MapY2=MapY

  If RectsOverlap(mx,my,1,1,WinX+WinW,WinY,8,WinH) 		;Vertical slider

		w1=WinH*WinH/MaxMapY   

		Ypos=WinY+MapY*(WinH-w1)/(MaxMapY-WinH)

		If mY<Ypos Then 

	  	MapY=(My-WinY)*(MaxMapY-WinH)/(WinH-w1)

	  	If my<WinY+4 Then MapY=0

		ElseIf My>Ypos+w1 Then

	  	MapY=(My-WinY-w1)*(MaxMapY-WinH)/(WinH-w1)

	  	If my>WinY+WinH-4 Then MapY=(MaxMapY-WinH)

		Else

			Slider_move(img,1)

		EndIf

  ElseIf  RectsOverlap(mx,my,1,1,WinX,WinY+WinH,WinW,8)	;Horizontial slider 

		w2=WinW*WinW/MaxMapX

		Xpos=WinX+MapX*(WinW-w2)/(MaxMapX-WinW)

		If mx<Xpos Then 

		  MapX=(MX-WinX)*(MaxMapX-WinW)/(WinW-w2)

		  If mX<WinX+4 Then MapX=0

		ElseIf MX>Xpos+w2 Then

		  MapX=(MX-WinX-w2)*(MaxMapX-WinW)/(WinW-w2)

	  	If mX>WinX+WinW-4 Then MapX=(MaxMapX-WinW)

	  Else

			Slider_move(img,2)

		EndIf

  Else

		Return False

  EndIf



  If MapX<0 Then MapX=0

  If MapY<0 Then MapY=0

  If MapX>(MaxMapX-WinW) Then MapX=(MaxMapX-WinW)

  If MapY>(MaxMapY-WinH) Then MapY=(MaxMapY-WinH)

  If MapX<>MapX2 Or MapY<>MapY2

	;redraw map only if necessary

	DrawScreenImage(img,0)

	Return True

  EndIf

End Function



Function Limit(xy,xy0,wh)

	If xy<xy0 Then Return xy0

	If xy>xy0+wh Then Return xy0+wh

	Return xy

End Function 



	

Function DrawRect(x0,y0,x2,y2,Fill)

  If x2>x0

	w=x2-x0

	If y2>y0 Then Rect x0,y0,w,y2-y0,fill Else Rect x0,y2,w,y0-y2,fill

  Else

  	w=x0-x2

	If y2>y0 Then Rect x2,y0,w,y2-y0,fill Else	Rect x2,y2,w,y0-y2,fill

  EndIf

End Function





Function fracture(x0,y0,x2,y2,H,Power#, counter)

	;Recursive routine for roughing up a line

	If counter<1

		Line x0,y0,x2,y2

	Else

		F=H :If Rnd(1)>.5 Then F=-H 

		x1=(x0+x2)/2+F

		F=H :If Rnd(1)>.5 Then F=-H 

		y1=(y0+y2)/2+F

		H=H^(power)

		fracture (x0,y0,x1,y1,H,Power,counter-1)

		fracture (x1,y1,x2,y2,H,Power,counter-1)

	EndIf 

End Function





Function flood_Fill(source,x,y,Pcolor)



	w=ImageWidth(source)

	h=ImageHeight(source)

	SBuffer=ImageBuffer(source)

	SetBuffer Sbuffer

	Dim PList(maxP)

	currentP=0

	LastP=0

	Plist(LastP)=y Shl 16 + x

	LockBuffer 

	WritePixelFast x,y,PColor

	Repeat

	Until Flood_Next(Pcolor,w,h)<1		

	UnlockBuffer



End Function





Function Flood_Next(PColor,w,h)



	;pull a point off the list of active points

	ActiveP=ActiveP-1

	x0=PList(currentP) And 65535

	Y0=PList(currentP) Shr 16

	;check the four adjacent pixels

	For i=1 To 4

	  x=x0+dirX(i)

	  y=y0+dirY(i)

	  If x<0 

	  ElseIf y<0

	  ElseIf x>W

	  ElseIf y>H

	  ElseIf ReadPixelFast(x,y)=0 Then

			; if blank, color and add to active list

		  WritePixelFast x,y,PColor

			LastP=LastP+1

			ActiveP=ActiveP+1

			If LastP>maxP Then LastP=0   ;wrap around if at end

			Plist(LastP)=y Shl 16 + x	 ;add pixel list

	  EndIf

	Next

	

	;If ActiveP>maxA Then maxA=ActiveP ;for debugging

	

	;set current point to next on list

	currentP=currentP+1

	If currentP>MaxP Then currentP = 0	;if at end wrap around



	Return 	ActiveP	 ;we're done when there's no more active points



End Function









;Data **************************************************************



.pointerdata

Data 11, 19, 0, 0

Data 526344 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0

Data 526344 ,526344 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0

Data 526344 ,16317688 ,526344 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0

Data 526344 ,16317688 ,16317688 ,526344 ,0 ,0 ,0 ,0 ,0 ,0 ,0

Data 526344 ,16317688 ,16317688 ,16317688 ,526344 ,0 ,0 ,0 ,0 ,0 ,0

Data 526344 ,16317688 ,16317688 ,16317688 ,16317688 ,526344 ,0 ,0 ,0 ,0 ,0

Data 526344 ,16317688 ,16317688 ,16317688 ,16317688 ,16317688 ,526344 ,0 ,0 ,0 ,0

Data 526344 ,16317688 ,16317688 ,16317688 ,16317688 ,16317688 ,16317688 ,526344 ,0 ,0 ,0

Data 526344 ,16317688 ,16317688 ,16317688 ,16317688 ,16317688 ,16317688 ,16317688 ,526344 ,0 ,0

Data 526344 ,16317688 ,16317688 ,16317688 ,16317688 ,16317688 ,16317688 ,16317688 ,16317688 ,526344 ,0

Data 526344 ,16317688 ,16317688 ,16317688 ,16317688 ,16317688 ,526344 ,526344 ,526344 ,526344 ,526344

Data 526344 ,16317688 ,16317688 ,526344 ,16317688 ,16317688 ,526344 ,0 ,0 ,0 ,0

Data 526344 ,16317688 ,526344 ,0 ,526344 ,16317688 ,16317688 ,526344 ,0 ,0 ,0

Data 526344 ,526344 ,0 ,0 ,526344 ,16317688 ,16317688 ,526344 ,0 ,0 ,0

Data 526344 ,0 ,0 ,0 ,0 ,526344 ,16317688 ,16317688 ,526344 ,0 ,0

Data 0 ,0 ,0 ,0 ,0 ,526344 ,16317688 ,16317688 ,526344 ,0 ,0

Data 0 ,0 ,0 ,0 ,0 ,0 ,526344 ,16317688 ,16317688 ,526344 ,0

Data 0 ,0 ,0 ,0 ,0 ,0 ,526344 ,16317688 ,16317688 ,526344 ,0

Data 0 ,0 ,0 ,0 ,0 ,0 ,0 ,526344 ,526344 ,0 ,0



.Movepointerdata

Data 25, 25, 12, 12

Data 0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0

Data 0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,16317688 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0

Data 0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,16317688 ,16317688 ,16317688 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0

Data 0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,16317688 ,0 ,16317688 ,0 ,16317688 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0

Data 0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,16317688 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0

Data 0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,16317688 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0

Data 0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,16317688 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0

Data 0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,16317688 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0

Data 0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,16317688 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0

Data 0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,16317688 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0

Data 0 ,0 ,0 ,16317688 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,16252928 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,16317688 ,0 ,0 ,0

Data 0 ,0 ,16317688 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,16317688 ,0 ,0

;this line broken in two

Data 0 ,16317688 ,16317688 ,16317688 ,16317688 ,16317688 ,16317688 ,16317688 ,16317688 ,16317688 ,16252928 ,0 ,16252928 

Data 0 ,16252928 ,16317688 ,16317688 ,16317688 ,16317688 ,16317688 ,16317688 ,16317688 ,16317688 ,16317688 ,0

Data 0 ,0 ,16317688 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,16317688 ,0 ,0

Data 0 ,0 ,0 ,16317688 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,16252928 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,16317688 ,0 ,0 ,0

Data 0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,16317688 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0

Data 0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,16317688 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0

Data 0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,16317688 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0

Data 0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,16317688 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0

Data 0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,16317688 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0

Data 0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,16317688 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0

Data 0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,16317688 ,0 ,16317688 ,0 ,16317688 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0

Data 0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,16317688 ,16317688 ,16317688 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0

Data 0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,16317688 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0

Data 0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0