Function Point_Insert(Seg,M,img)

	nLineSeg=nLineSeg+1

	MasRect(M,6)=MasRect(M,6)+1		;number of points contain in Master Rect

	LineSeg(nLineSeg,0)=M		 	;Parent

	Pseg=LineSeg(seg,6)

	LineSeg(nLineSeg,1)=(LineSeg(seg,1)+LineSeg(Pseg,1)) Shr 1	

	LineSeg(nLineSeg,2)=(LineSeg(seg,2)+LineSeg(Pseg,2)) Shr 1	

	

	LineSeg(nLineSeg,5)= seg	;next= current segiment

	LineSeg(nLineSeg,6)= Pseg	;prev  = current segiments previous segiment

	LineSeg(Seg,6)=nLineSeg		;update current segiment to point back to new segiment	

	LineSeg(Pseg,5)=nLineSeg	;update previous(seg) segiment to point to new segiment

	Point_set(M,nLineSeg)



	Master_MinMax(M)

	DrawBlock img,0,0	

	Master_Draw(M)

	GrabImage img,0,0



End Function 





Function Point_set(M,Seg)

  Select MasRect(M,0)

  Case 1	;line

		LineSeg(Seg,3)=0 					

		LineSeg(Seg,4)=0 					

  Case 2	;fractal

		LineSeg(Seg,3)=MilliSecs()		;random number seed

		LineSeg(Seg,4)=10+ (4 Shl 8) + (55 Shl 16) 					

  Case 3	;bezier

	;put control midway between current segiment point and next point

		LineSeg(Seg,3)=(LineSeg(Seg,1)+ LineSeg(LineSeg(Seg,5),1)) Shr 1

		LineSeg(Seg,4)=(LineSeg(Seg,2)+ LineSeg(LineSeg(Seg,5),2)) Shr 1

  End Select

  Return

End Function





Function Point_add()

	For s=1 To nLineSeg

		If LineSeg(s,0)=0 Then Return s

	Next 

	nLineSeg=nLineSeg+1

	Return nLineSeg

End Function	





Function Point_Delete(Seg,M,img)



	If MasRect(M,6)=3 Then Return 	;must have at least 3 points

	If MasRect(M,5)=seg Then 

		message("Can't delete first segment!",3000,img)

		Return

	EndIf

	MasRect(M,6)=MasRect(M,6)-1		;number of points contain in Master Rect	

	Pseg=LineSeg(seg,6)

	Nseg=LineSeg(Seg,5)

	If masrect(M,0)=3 Then 

	  LineSeg(PSeg,3)=LineSeg(Seg,1)

	  LineSeg(PSeg,4)=LineSeg(Seg,2)

	EndIf

	For i=0 To 6

	  LineSeg(Seg,i)=0		 				

	Next



	LineSeg(Pseg,5)= Nseg		

	LineSeg(Nseg,6)= Pseg	

	Master_MinMax(M)

	DrawBlock img,0,0	

	Master_Draw(M)

	GrabImage img,0,0

	Return

	

End Function





Function Point_Move(Seg,M,img)

	DrawScreenImage(img,M)

	While MouseDown(1)

		mx=MouseX():  	x2=mx+MapX-WinX

		my=MouseY():	y2=my+MapY-WinY

		x2=Limit(x2,MasRect(M,1),MasRect(M,3))

		y2=Limit(y2,MasRect(M,2),MasRect(M,4))

		;origin for line segiments is master x,y

		LineSeg(Seg,1)=x2-MasRect(M,1)

		LineSeg(Seg,2)=y2-MasRect(M,2)

		DrawBlock img,0,0

		UpdatePosition(mx,mY,"Point_Move")

		Master_Draw(M)

		ColorSet(white)

		Text 0,0,Str$(x2)+"  "+Str$(y2)

		DrawImage MouseImage, mx,my

		Flip

	Wend

	Master_MinMax(M)

	DrawBlock img,0,0	

	Master_Draw(M)

	GrabImage img,0,0

	Return

End Function 



	

Function Point_Find(M,sx,sy)

 	If M<>Master_Find(sx,sy) Then Return -1

	Seg=MasRect(M,5)

	Repeat

	  x=LineSeg(Seg,1)+MasRect(M,1)-3

	  y=LineSeg(Seg,2)+MasRect(M,2)-3

	  If RectsOverlap(sx,sy,1,1,x,y,7,7) Then 

		Return seg

	  Else

		seg=LineSeg(Seg,5)

	  EndIf

	  If LineSeg(Seg,0)<>M Then Return 0

	Until Seg=MasRect(M,5)

	Return 0

End Function 



Function Master_MinMax(s)

	;sets the minium border size for Master rectangle

	;this is to prevent the master from being resize

	;such that a line point is outside the master rectangle

	maxX=0: maxY=0: minX=lowB: minY=lowB

	Seg=MasRect(s,5)

	Repeat

	  If LineSeg(Seg,1)>MaxX Then MaxX=LineSeg(Seg,1)

	  If LineSeg(Seg,1)<MinX Then MinX=LineSeg(Seg,1)

	  If LineSeg(Seg,2)>MaxY Then MaxY=LineSeg(Seg,2)

	  If LineSeg(Seg,2)<MinY Then MinY=LineSeg(Seg,2)

	  seg=LineSeg(Seg,5)

	  If seg<0 Then Exit	

	Until Seg=MasRect(s,5)

	MasRect(s,7)=MinX

	MasRect(s,8)=MinY

	MasRect(s,9)=MaxX

	MasRect(s,10)=MaxY

	

End Function 





Function Master_Find(sx,sy)

  For i=1 To nMasRect

		If RectsOverlap(sx,sy,1,1,MasRect(i,1),MasRect(i,2),MasRect(i,3),MasRect(i,4)) Then Return i

  Next

  ;not found

  Return 0

End Function 





Function Master_Add(mx0,my0,img)



	While MouseDown(1)

		mx2=MouseX()

		my2=MouseY()

		DrawBlock img,0,0

		Color 255,0,0

		DrawRect(mx0,my0,mx2,my2,0)

		DrawImage MouseImage, mx2,my2

		UpdatePosition(mx2,mY2,"Master Add")

		Color 255,255,255

		Text 500,0, "Width: "+Str$(Abs(mx2-mx0))+"  Height: "+ Str$(Abs(my2-my0))

		Flip

	Wend

	

	If mx2=mx0 Then Return

	If my2=my0 Then Return



	For i=1 To nMasRect

		If MasRect(i,0)=0 Then M=i: Exit

	Next 

	If M=0 Then nMasRect=nMasRect+1: M=nMasRect

	

	MasRect(M,0)=BorderDefault	;type  1=line,2=fractial,3=bezier

	If mx2>mx0 Then sx= Scrn2MapX(mx0-4) Else  sx=Scrn2MapX(mx2-4)

	MasRect(M,1)=sx

	If my2>my0 Then sy= Scrn2MapY(my0-4) Else  sy=Scrn2MapY(my2-4)

	MasRect(M,2)=sy



	w=Abs(mx2-mx0)

	h=Abs(my2-my0)

	MasRect(M,3)=w+8					;master width

	MasRect(M,4)=h+8					;master height

	MasRect(M,5)=nLineSeg+1	;start segment

	MasRect(M,6)=8						;number of segments

	MasRect(M,11)=w/2+4			;X Center control point

	MasRect(M,12)=h/2+4			;Y Center control point

	MasRect(M,13)=default_fill

	;fill type and Lock (bit 17)

	SeedRnd MilliSecs()

	

	Dim pts(8)

	For i=1 To 8

		S=Point_add()

		pts(i)=S

		LineSeg(s,0)= M				;Parent

		LineSeg(s,1)=4+(w*scdat(i,2) Shr 1) 	;x rel to master

		LineSeg(s,2)=4+(h*scdat(i,3) Shr 1) 	;y rel to master

		LineSeg(s,6)=pts(i-1) 	;prev point

	Next

	For i=1 To 7

		LineSeg(pts(i),5)=pts(i+1)	;next point

	Next

	LineSeg(pts(1),6)=pts(8)	;prev first points to last

	LineSeg(pts(8),5)=pts(1)	;next last points to first

	

	;set control points

	For i=1 To 8

	  Point_set(M,pts(i))

 	Next

	Master_MinMax(M)

	Master_Image(M)

	DrawScreenImage(img,0)

	

End Function





Function Master_Copy(M,img)



	For i=1 To nMasRect

		If MasRect(i,0)=0 Then M=i: Exit

	Next 

	If M=0 Then nMasRect=nMasRect+1: M=nMasRect

	

	For i=0 To 13

		MasRect(M,i)=MasRect(M,i)

	Next

	MasRect(M,1)=MasRect(M,1)+50

  MasRect(M,2)=MasRect(M,2)+50

	MasRect(M,5)=nLineSeg+1	;start segment

	MasRect(M,14)=0		;set handle zero, Mast_image will create

	

	Seg=MasRect(M,5)

	Repeat

	  nLineSeg=nLineSeg+1

		LineSeg(nLineSeg,0)= M				;Parent

		For i=1 To 4

			LineSeg(nLineSeg,i)=LineSeg(seg,i)

		Next

		LineSeg(nLineSeg,5)=nLineSeg+1 	;next

		LineSeg(nLineSeg,6)=nLineSeg-1 	;prev

	  Seg=LineSeg(Seg,5)

	  If seg<0 Then Exit	

	Until Seg=MasRect(M,5)

	LineSeg(nLineSeg,5)						=MasRect(M,5) 	;next

	LineSeg(MasRect(M,5),6)=nLineSeg 						;prev

	

	cMast=M

	Master_Image(M)

	DrawScreenImage(img,0)



End Function





Function Master_Delete(M,img)

		If M<1 Then Return

		Dim Atext$(10)

		Atext$(1)="Delete Master Rectangle "+Str$(M)

		button$(1)=" Delete "

		button$(2)=" Cancel "	

		choice=ALERT(2,2,img)

		If choice=2 Then Return

	

		MasRect(M,0)=0

		FreeImage MasRect(M,14)

		MasRect(M,14)=0

		MasRect(M,1)=-1

		MasRect(M,2)=-1

		MasRect(M,3)=0

		MasRect(M,4)=0

		

		nextSeg=MasRect(M,5)

		Repeat

		  LineSeg(nextSeg,0)=0	;set master to null to mark for elimination

		  nextSeg=LineSeg(Seg,5)

		  If nextseg<1 Then Exit	

		Until nextSeg=MasRect(M,5)

		DrawScreenImage(img,0)

End Function





Function Master_Image(m)

	;assumes backbuffer is active and calling routine will refresh on return

	If MasRect(M,0)=0 Then Return		;deleted master

	If MasRect(M,14)>0 Then FreeImage MasRect(M,14)

	MasRect(M,14) = CreateImage(MasRect(M,3),MasRect(M,4))

	Cls

	Color 255,255,255



 	;Rect 1,1,MasRect(m,3),MasRect(M,4),0

	nextSeg=MasRect(M,5)

	Repeat

	  nextSeg=DrawLineSeg(M,nextSeg,False)

	  If nextseg<0 Then Exit	

	Until nextSeg=MasRect(M,5)



	GrabImage MasRect(M,14),0,0

	mx=MouseX(): my=MouseY()

	MoveMouse ScrnW+40,ScrnH+40		;To prevent window's mouse pointer from being over written

	flood_Fill(MasRect(M,14),MasRect(M,11),MasRect(M,12),255*256)



	SetBuffer BackBuffer()

	;Origin 0,0

	Viewport 0,0,MasRect(M,3),MasRect(M,4)

	f=MasRect(M,13) And lowB

	TileBlock pattern(f),0,0

	MaskImage MasRect(M,14),0,255,0

	DrawImage MasRect(M,14),0,0

	GrabImage MasRect(M,14),0,0

	MaskImage MasRect(M,14),0,0,0	



	MoveMouse mx,my

	Viewport 0,0,scrnW,scrnH



	Return

End Function





Function Master_Draw(M)

	If MasRect(M,0)=0 Then Return

	Color 255,0,0	;outside border

	Origin WinX-MapX,WinY-MapY

	Color 255,0,0

 	Rect MasRect(M,1),MasRect(M,2),MasRect(M,3),MasRect(M,4), fill

	Color 0,0,0		;drag bars

	Rect MasRect(M,1)+MasRect(M,3), MasRect(M,2)+MasRect(M,4)/2-4,4,8

	Rect MasRect(M,1)+MasRect(M,3)/2-4, MasRect(M,2)+MasRect(M,4),8,4

	Rect MasRect(M,1)-4, MasRect(M,2)+MasRect(M,4)/2-4,4,8

	Rect MasRect(M,1)+MasRect(M,3)/2-4, MasRect(M,2)-4,8,4



	Color 255,255,255

	Origin MasRect(M,1)-MapX+WinX,MasRect(M,2)-MapY+WinY

	nextSeg=MasRect(M,5)

	Repeat

	  nextSeg=DrawLineSeg(M,nextSeg,True)

	  If nextseg<0 Then Exit	

	Until nextSeg=MasRect(M,5)

	Rect MasRect(M,11)-3,MasRect(M,12)-3,7,7,0

	Origin 0,0

End Function





Function Master_Center(M,sx,sy,img)

  	cenx=MasRect(M,11)+MasRect(M,1)-3

  	ceny=MasRect(M,12)+MasRect(M,2)-3



  	If Not RectsOverlap(cenx,ceny,7,7,sx,sy,1,1) Then Return False



	DrawScreenImage(img,M)

	While MouseDown(1)

		mx=MouseX():	cenX=mx+MapX-WinX-MasRect(M,1)

		my=MouseY():	cenY=my+MapY-WinY-MasRect(M,2)

		MasRect(M,11)=MiniMax(cenX,0,MasRect(M,3))

		MasRect(M,12)=MiniMax(cenY,0,MasRect(M,4))

		DrawBlock img,0,0

		UpdatePosition(mx,mY,"Move Center")

		Master_Draw(M)

		DrawImage MouseImage, mx,my

		Flip

	Wend



	Cls

	DrawBlock img,0,0	

	Master_Draw(M)

	GrabImage img,0,0	

	Return True

		

End Function



Function Master_Resize(M,x,y,img)

	x0=MasRect(M,1)-4

	x1=MasRect(M,1)+MasRect(M,3)

	x2=MasRect(M,1)+MasRect(M,3)/2-4

	y0=MasRect(M,2)-4

	y1=MasRect(M,2)+MasRect(M,4)/2-4

	y2=MasRect(M,2)+MasRect(M,4)

	If RectsOverlap(x1,y1,4,8,x,y,1,1) Then

		ChangeSide=1

	ElseIf RectsOverlap(x2,y2,8,4,x,y,1,1) Then

		ChangeSide=2

	ElseIf RectsOverlap(x0,y1,4,8,x,y,1,1) Then

		ChangeSide=3

	ElseIf RectsOverlap(x2,y0,8,4,x,y,1,1) Then

		ChangeSide=4

	Else

	  Return False

	EndIf	

	;draw screen without the Master Rect being moved

	DrawScreenImage(img,M)



	While MouseDown(1)

		mx=MouseX():	x3=mx+MapX-WinX

		my=MouseY():	y3=my+MapY-WinY

		Select ChangeSide

		Case 1

		  w=x3-MasRect(M,1)

		  If X3>(MasRect(M,9)+MasRect(M,1)) Then MasRect(M,3)=w

		Case 2

		  h=y3-MasRect(M,2)

		  If h>MasRect(M,10) Then MasRect(M,4)=h

		Case 3

		  w=MAX(MasRect(M,1)-x3+MasRect(M,3),8)

		  dx=MasRect(M,1)-x3

			MasRect(M,1)=x3

			MasRect(M,3)=w

			Seg=MasRect(M,5)

			Repeat

			  LineSeg(Seg,1)=LineSeg(Seg,1)+dx

				If MasRect(M,0)=3 Then LineSeg(Seg,3)=LineSeg(Seg,3)+dx

			  Seg=LineSeg(Seg,5)

			  If seg<0 Then Exit	

			Until Seg=MasRect(M,5)

		Case 4

		  h=MAX(MasRect(M,2)-y3+MasRect(M,4),8)

			dy=MasRect(M,2)-y3

			MasRect(M,2)=y3

			MasRect(M,4)=h

			Seg=MasRect(M,5)

			Repeat

			  LineSeg(Seg,2)=LineSeg(Seg,2)+dy

				If MasRect(M,0)=3 Then  LineSeg(Seg,4)=LineSeg(Seg,4)+dy

			  Seg=LineSeg(Seg,5)

			  If seg<0 Then Exit	

			Until Seg=MasRect(M,5)

		End Select

		

		DrawBlock img,0,0

		UpdatePosition(mx,mY,"ReSize")

		Master_Draw(M)

		DrawImage MouseImage, mx,my

		Flip

	Wend



	Cls

	DrawBlock img,0,0

	Master_MinMax(M)

	Master_Draw(M)	

	GrabImage img,0,0

	Return True



End Function





Function Master_Move(M,img)

	If MasRect(M,13) And lockbit Then

	  Return

	EndIf

	;offset from Master x,y to mouse x,y

	dx=MouseX()-MasRect(M,1)

	dy=MouseY()-MasRect(M,2)

	;draw screen without the Master Rect being moved

	DrawScreenImage(img,M)

	

	While MouseDown(1)

		x2=MouseX()

		y2=MouseY()

		MasRect(M,1)=x2-dx

		MasRect(M,2)=y2-dy

		DrawBlock img,0,0

		UpdatePosition(mx,mY,"Master_Move")

		Viewport winX,winY,winW,winH

		Master_Draw(M)

		DrawImage MouseImage, x2,y2

		Viewport 0,0,scrnW,scrnH

		Flip

	Wend

	DrawBlock img,0,0	

	Master_Draw(M)

	GrabImage img,0,0

	Return



End Function 



Function Control_Find(M,sx,sy,img)

 	;If M<>Master_Find(sx,sy) Then Return 0

	If MasRect(M,0)<>3 Then Return False ;not a bezeir shape

	Seg=MasRect(M,5) ;segment to start search with

	Repeat

	  x=LineSeg(Seg,3)+MasRect(M,1)-3

	  y=LineSeg(Seg,4)+MasRect(M,2)-3

	  If RectsOverlap(sx,sy,1,1,x,y,7,7) Then

			;bezeir control point found go ahead and move it

			cSeg=seg

	  	Control_Move(seg,M,img)			

			Return True

	  Else

			seg=LineSeg(Seg,5)

	  EndIf

	  If LineSeg(Seg,0)<>M Then Return False

	Until Seg=MasRect(M,5)

	Return False

End Function 



Function Control_Move(Seg,M,img)

	DrawScreenImage(img,M)

	While MouseDown(1)

		mx=MouseX():  x2=mx+MapX-WinX

		my=MouseY():	y2=my+MapY-WinY

		;x2=Limit(x2,MasRect(M,1),MasRect(M,3))

		;y2=Limit(y2,MasRect(M,2),MasRect(M,4))

		;origin for line segiments is master x,y

		LineSeg(Seg,3)=x2-MasRect(M,1)

		LineSeg(Seg,4)=y2-MasRect(M,2)

		DrawBlock img,0,0

		UpdatePosition(mx,mY,"Control_Move")

		Master_Draw(M)

		ColorSet(white)

		Text 0,0,Str$(x2)+"  "+Str$(y2)

		DrawImage MouseImage, mx,my

		Flip

	Wend

	Master_MinMax(M)

	DrawBlock img,0,0	

	Master_Draw(M)

	GrabImage img,0,0

	Return

End Function 

